/// Generated client implementations.
pub mod session_admin_client {
    #![allow(
        unused_variables,
        dead_code,
        missing_docs,
        clippy::wildcard_imports,
        clippy::let_unit_value,
    )]
    use tonic::codegen::*;
    use tonic::codegen::http::Uri;
    #[derive(Debug, Clone)]
    pub struct SessionAdminClient<T> {
        inner: tonic::client::Grpc<T>,
    }
    impl SessionAdminClient<tonic::transport::Channel> {
        /// Attempt to create a new client by connecting to a given endpoint.
        pub async fn connect<D>(dst: D) -> Result<Self, tonic::transport::Error>
        where
            D: TryInto<tonic::transport::Endpoint>,
            D::Error: Into<StdError>,
        {
            let conn = tonic::transport::Endpoint::new(dst)?.connect().await?;
            Ok(Self::new(conn))
        }
    }
    impl<T> SessionAdminClient<T>
    where
        T: tonic::client::GrpcService<tonic::body::Body>,
        T::Error: Into<StdError>,
        T::ResponseBody: Body<Data = Bytes> + std::marker::Send + 'static,
        <T::ResponseBody as Body>::Error: Into<StdError> + std::marker::Send,
    {
        pub fn new(inner: T) -> Self {
            let inner = tonic::client::Grpc::new(inner);
            Self { inner }
        }
        pub fn with_origin(inner: T, origin: Uri) -> Self {
            let inner = tonic::client::Grpc::with_origin(inner, origin);
            Self { inner }
        }
        pub fn with_interceptor<F>(
            inner: T,
            interceptor: F,
        ) -> SessionAdminClient<InterceptedService<T, F>>
        where
            F: tonic::service::Interceptor,
            T::ResponseBody: Default,
            T: tonic::codegen::Service<
                http::Request<tonic::body::Body>,
                Response = http::Response<
                    <T as tonic::client::GrpcService<tonic::body::Body>>::ResponseBody,
                >,
            >,
            <T as tonic::codegen::Service<
                http::Request<tonic::body::Body>,
            >>::Error: Into<StdError> + std::marker::Send + std::marker::Sync,
        {
            SessionAdminClient::new(InterceptedService::new(inner, interceptor))
        }
        /// Compress requests with the given encoding.
        ///
        /// This requires the server to support it otherwise it might respond with an
        /// error.
        #[must_use]
        pub fn send_compressed(mut self, encoding: CompressionEncoding) -> Self {
            self.inner = self.inner.send_compressed(encoding);
            self
        }
        /// Enable decompressing responses.
        #[must_use]
        pub fn accept_compressed(mut self, encoding: CompressionEncoding) -> Self {
            self.inner = self.inner.accept_compressed(encoding);
            self
        }
        /// Limits the maximum size of a decoded message.
        ///
        /// Default: `4MB`
        #[must_use]
        pub fn max_decoding_message_size(mut self, limit: usize) -> Self {
            self.inner = self.inner.max_decoding_message_size(limit);
            self
        }
        /// Limits the maximum size of an encoded message.
        ///
        /// Default: `usize::MAX`
        #[must_use]
        pub fn max_encoding_message_size(mut self, limit: usize) -> Self {
            self.inner = self.inner.max_encoding_message_size(limit);
            self
        }
        pub async fn list_workspace_sessions(
            &mut self,
            request: impl tonic::IntoRequest<
                crate::admin::generated::admin::ListWorkspaceSessionsRequest,
            >,
        ) -> std::result::Result<
            tonic::Response<
                crate::admin::generated::admin::ListWorkspaceSessionsResponse,
            >,
            tonic::Status,
        > {
            self.inner
                .ready()
                .await
                .map_err(|e| {
                    tonic::Status::unknown(
                        format!("Service was not ready: {}", e.into()),
                    )
                })?;
            let codec = tonic_prost::ProstCodec::default();
            let path = http::uri::PathAndQuery::from_static(
                "/admin.SessionAdmin/ListWorkspaceSessions",
            );
            let mut req = request.into_request();
            req.extensions_mut()
                .insert(GrpcMethod::new("admin.SessionAdmin", "ListWorkspaceSessions"));
            self.inner.unary(req, path, codec).await
        }
        pub async fn list_user_sessions(
            &mut self,
            request: impl tonic::IntoRequest<
                crate::admin::generated::admin::ListUserSessionsRequest,
            >,
        ) -> std::result::Result<
            tonic::Response<crate::admin::generated::admin::ListUserSessionsResponse>,
            tonic::Status,
        > {
            self.inner
                .ready()
                .await
                .map_err(|e| {
                    tonic::Status::unknown(
                        format!("Service was not ready: {}", e.into()),
                    )
                })?;
            let codec = tonic_prost::ProstCodec::default();
            let path = http::uri::PathAndQuery::from_static(
                "/admin.SessionAdmin/ListUserSessions",
            );
            let mut req = request.into_request();
            req.extensions_mut()
                .insert(GrpcMethod::new("admin.SessionAdmin", "ListUserSessions"));
            self.inner.unary(req, path, codec).await
        }
        pub async fn kick_user_from_workspace(
            &mut self,
            request: impl tonic::IntoRequest<
                crate::admin::generated::admin::KickUserFromWorkspaceRequest,
            >,
        ) -> std::result::Result<
            tonic::Response<
                crate::admin::generated::admin::KickUserFromWorkspaceResponse,
            >,
            tonic::Status,
        > {
            self.inner
                .ready()
                .await
                .map_err(|e| {
                    tonic::Status::unknown(
                        format!("Service was not ready: {}", e.into()),
                    )
                })?;
            let codec = tonic_prost::ProstCodec::default();
            let path = http::uri::PathAndQuery::from_static(
                "/admin.SessionAdmin/KickUserFromWorkspace",
            );
            let mut req = request.into_request();
            req.extensions_mut()
                .insert(GrpcMethod::new("admin.SessionAdmin", "KickUserFromWorkspace"));
            self.inner.unary(req, path, codec).await
        }
        pub async fn kick_user(
            &mut self,
            request: impl tonic::IntoRequest<
                crate::admin::generated::admin::KickUserRequest,
            >,
        ) -> std::result::Result<
            tonic::Response<crate::admin::generated::admin::KickUserResponse>,
            tonic::Status,
        > {
            self.inner
                .ready()
                .await
                .map_err(|e| {
                    tonic::Status::unknown(
                        format!("Service was not ready: {}", e.into()),
                    )
                })?;
            let codec = tonic_prost::ProstCodec::default();
            let path = http::uri::PathAndQuery::from_static(
                "/admin.SessionAdmin/KickUser",
            );
            let mut req = request.into_request();
            req.extensions_mut()
                .insert(GrpcMethod::new("admin.SessionAdmin", "KickUser"));
            self.inner.unary(req, path, codec).await
        }
        pub async fn get_user_status(
            &mut self,
            request: impl tonic::IntoRequest<
                crate::admin::generated::admin::GetUserStatusRequest,
            >,
        ) -> std::result::Result<
            tonic::Response<crate::admin::generated::admin::GetUserStatusResponse>,
            tonic::Status,
        > {
            self.inner
                .ready()
                .await
                .map_err(|e| {
                    tonic::Status::unknown(
                        format!("Service was not ready: {}", e.into()),
                    )
                })?;
            let codec = tonic_prost::ProstCodec::default();
            let path = http::uri::PathAndQuery::from_static(
                "/admin.SessionAdmin/GetUserStatus",
            );
            let mut req = request.into_request();
            req.extensions_mut()
                .insert(GrpcMethod::new("admin.SessionAdmin", "GetUserStatus"));
            self.inner.unary(req, path, codec).await
        }
        pub async fn get_user_info(
            &mut self,
            request: impl tonic::IntoRequest<
                crate::admin::generated::admin::GetUserInfoRequest,
            >,
        ) -> std::result::Result<
            tonic::Response<crate::admin::generated::admin::GetUserInfoResponse>,
            tonic::Status,
        > {
            self.inner
                .ready()
                .await
                .map_err(|e| {
                    tonic::Status::unknown(
                        format!("Service was not ready: {}", e.into()),
                    )
                })?;
            let codec = tonic_prost::ProstCodec::default();
            let path = http::uri::PathAndQuery::from_static(
                "/admin.SessionAdmin/GetUserInfo",
            );
            let mut req = request.into_request();
            req.extensions_mut()
                .insert(GrpcMethod::new("admin.SessionAdmin", "GetUserInfo"));
            self.inner.unary(req, path, codec).await
        }
        pub async fn get_workspace_online_users(
            &mut self,
            request: impl tonic::IntoRequest<
                crate::admin::generated::admin::GetWorkspaceOnlineUsersRequest,
            >,
        ) -> std::result::Result<
            tonic::Response<
                crate::admin::generated::admin::GetWorkspaceOnlineUsersResponse,
            >,
            tonic::Status,
        > {
            self.inner
                .ready()
                .await
                .map_err(|e| {
                    tonic::Status::unknown(
                        format!("Service was not ready: {}", e.into()),
                    )
                })?;
            let codec = tonic_prost::ProstCodec::default();
            let path = http::uri::PathAndQuery::from_static(
                "/admin.SessionAdmin/GetWorkspaceOnlineUsers",
            );
            let mut req = request.into_request();
            req.extensions_mut()
                .insert(
                    GrpcMethod::new("admin.SessionAdmin", "GetWorkspaceOnlineUsers"),
                );
            self.inner.unary(req, path, codec).await
        }
        pub async fn is_user_online(
            &mut self,
            request: impl tonic::IntoRequest<
                crate::admin::generated::admin::IsUserOnlineRequest,
            >,
        ) -> std::result::Result<
            tonic::Response<crate::admin::generated::admin::IsUserOnlineResponse>,
            tonic::Status,
        > {
            self.inner
                .ready()
                .await
                .map_err(|e| {
                    tonic::Status::unknown(
                        format!("Service was not ready: {}", e.into()),
                    )
                })?;
            let codec = tonic_prost::ProstCodec::default();
            let path = http::uri::PathAndQuery::from_static(
                "/admin.SessionAdmin/IsUserOnline",
            );
            let mut req = request.into_request();
            req.extensions_mut()
                .insert(GrpcMethod::new("admin.SessionAdmin", "IsUserOnline"));
            self.inner.unary(req, path, codec).await
        }
    }
}
/// Generated server implementations.
pub mod session_admin_server {
    #![allow(
        unused_variables,
        dead_code,
        missing_docs,
        clippy::wildcard_imports,
        clippy::let_unit_value,
    )]
    use tonic::codegen::*;
    /// Generated trait containing gRPC methods that should be implemented for use with SessionAdminServer.
    #[async_trait]
    pub trait SessionAdmin: std::marker::Send + std::marker::Sync + 'static {
        async fn list_workspace_sessions(
            &self,
            request: tonic::Request<
                crate::admin::generated::admin::ListWorkspaceSessionsRequest,
            >,
        ) -> std::result::Result<
            tonic::Response<
                crate::admin::generated::admin::ListWorkspaceSessionsResponse,
            >,
            tonic::Status,
        >;
        async fn list_user_sessions(
            &self,
            request: tonic::Request<
                crate::admin::generated::admin::ListUserSessionsRequest,
            >,
        ) -> std::result::Result<
            tonic::Response<crate::admin::generated::admin::ListUserSessionsResponse>,
            tonic::Status,
        >;
        async fn kick_user_from_workspace(
            &self,
            request: tonic::Request<
                crate::admin::generated::admin::KickUserFromWorkspaceRequest,
            >,
        ) -> std::result::Result<
            tonic::Response<
                crate::admin::generated::admin::KickUserFromWorkspaceResponse,
            >,
            tonic::Status,
        >;
        async fn kick_user(
            &self,
            request: tonic::Request<crate::admin::generated::admin::KickUserRequest>,
        ) -> std::result::Result<
            tonic::Response<crate::admin::generated::admin::KickUserResponse>,
            tonic::Status,
        >;
        async fn get_user_status(
            &self,
            request: tonic::Request<crate::admin::generated::admin::GetUserStatusRequest>,
        ) -> std::result::Result<
            tonic::Response<crate::admin::generated::admin::GetUserStatusResponse>,
            tonic::Status,
        >;
        async fn get_user_info(
            &self,
            request: tonic::Request<crate::admin::generated::admin::GetUserInfoRequest>,
        ) -> std::result::Result<
            tonic::Response<crate::admin::generated::admin::GetUserInfoResponse>,
            tonic::Status,
        >;
        async fn get_workspace_online_users(
            &self,
            request: tonic::Request<
                crate::admin::generated::admin::GetWorkspaceOnlineUsersRequest,
            >,
        ) -> std::result::Result<
            tonic::Response<
                crate::admin::generated::admin::GetWorkspaceOnlineUsersResponse,
            >,
            tonic::Status,
        >;
        async fn is_user_online(
            &self,
            request: tonic::Request<crate::admin::generated::admin::IsUserOnlineRequest>,
        ) -> std::result::Result<
            tonic::Response<crate::admin::generated::admin::IsUserOnlineResponse>,
            tonic::Status,
        >;
    }
    #[derive(Debug)]
    pub struct SessionAdminServer<T> {
        inner: Arc<T>,
        accept_compression_encodings: EnabledCompressionEncodings,
        send_compression_encodings: EnabledCompressionEncodings,
        max_decoding_message_size: Option<usize>,
        max_encoding_message_size: Option<usize>,
    }
    impl<T> SessionAdminServer<T> {
        pub fn new(inner: T) -> Self {
            Self::from_arc(Arc::new(inner))
        }
        pub fn from_arc(inner: Arc<T>) -> Self {
            Self {
                inner,
                accept_compression_encodings: Default::default(),
                send_compression_encodings: Default::default(),
                max_decoding_message_size: None,
                max_encoding_message_size: None,
            }
        }
        pub fn with_interceptor<F>(
            inner: T,
            interceptor: F,
        ) -> InterceptedService<Self, F>
        where
            F: tonic::service::Interceptor,
        {
            InterceptedService::new(Self::new(inner), interceptor)
        }
        /// Enable decompressing requests with the given encoding.
        #[must_use]
        pub fn accept_compressed(mut self, encoding: CompressionEncoding) -> Self {
            self.accept_compression_encodings.enable(encoding);
            self
        }
        /// Compress responses with the given encoding, if the client supports it.
        #[must_use]
        pub fn send_compressed(mut self, encoding: CompressionEncoding) -> Self {
            self.send_compression_encodings.enable(encoding);
            self
        }
        /// Limits the maximum size of a decoded message.
        ///
        /// Default: `4MB`
        #[must_use]
        pub fn max_decoding_message_size(mut self, limit: usize) -> Self {
            self.max_decoding_message_size = Some(limit);
            self
        }
        /// Limits the maximum size of an encoded message.
        ///
        /// Default: `usize::MAX`
        #[must_use]
        pub fn max_encoding_message_size(mut self, limit: usize) -> Self {
            self.max_encoding_message_size = Some(limit);
            self
        }
    }
    impl<T, B> tonic::codegen::Service<http::Request<B>> for SessionAdminServer<T>
    where
        T: SessionAdmin,
        B: Body + std::marker::Send + 'static,
        B::Error: Into<StdError> + std::marker::Send + 'static,
    {
        type Response = http::Response<tonic::body::Body>;
        type Error = std::convert::Infallible;
        type Future = BoxFuture<Self::Response, Self::Error>;
        fn poll_ready(
            &mut self,
            _cx: &mut Context<'_>,
        ) -> Poll<std::result::Result<(), Self::Error>> {
            Poll::Ready(Ok(()))
        }
        fn call(&mut self, req: http::Request<B>) -> Self::Future {
            match req.uri().path() {
                "/admin.SessionAdmin/ListWorkspaceSessions" => {
                    #[allow(non_camel_case_types)]
                    struct ListWorkspaceSessionsSvc<T: SessionAdmin>(pub Arc<T>);
                    impl<
                        T: SessionAdmin,
                    > tonic::server::UnaryService<
                        crate::admin::generated::admin::ListWorkspaceSessionsRequest,
                    > for ListWorkspaceSessionsSvc<T> {
                        type Response = crate::admin::generated::admin::ListWorkspaceSessionsResponse;
                        type Future = BoxFuture<
                            tonic::Response<Self::Response>,
                            tonic::Status,
                        >;
                        fn call(
                            &mut self,
                            request: tonic::Request<
                                crate::admin::generated::admin::ListWorkspaceSessionsRequest,
                            >,
                        ) -> Self::Future {
                            let inner = Arc::clone(&self.0);
                            let fut = async move {
                                <T as SessionAdmin>::list_workspace_sessions(
                                        &inner,
                                        request,
                                    )
                                    .await
                            };
                            Box::pin(fut)
                        }
                    }
                    let accept_compression_encodings = self.accept_compression_encodings;
                    let send_compression_encodings = self.send_compression_encodings;
                    let max_decoding_message_size = self.max_decoding_message_size;
                    let max_encoding_message_size = self.max_encoding_message_size;
                    let inner = self.inner.clone();
                    let fut = async move {
                        let method = ListWorkspaceSessionsSvc(inner);
                        let codec = tonic_prost::ProstCodec::default();
                        let mut grpc = tonic::server::Grpc::new(codec)
                            .apply_compression_config(
                                accept_compression_encodings,
                                send_compression_encodings,
                            )
                            .apply_max_message_size_config(
                                max_decoding_message_size,
                                max_encoding_message_size,
                            );
                        let res = grpc.unary(method, req).await;
                        Ok(res)
                    };
                    Box::pin(fut)
                }
                "/admin.SessionAdmin/ListUserSessions" => {
                    #[allow(non_camel_case_types)]
                    struct ListUserSessionsSvc<T: SessionAdmin>(pub Arc<T>);
                    impl<
                        T: SessionAdmin,
                    > tonic::server::UnaryService<
                        crate::admin::generated::admin::ListUserSessionsRequest,
                    > for ListUserSessionsSvc<T> {
                        type Response = crate::admin::generated::admin::ListUserSessionsResponse;
                        type Future = BoxFuture<
                            tonic::Response<Self::Response>,
                            tonic::Status,
                        >;
                        fn call(
                            &mut self,
                            request: tonic::Request<
                                crate::admin::generated::admin::ListUserSessionsRequest,
                            >,
                        ) -> Self::Future {
                            let inner = Arc::clone(&self.0);
                            let fut = async move {
                                <T as SessionAdmin>::list_user_sessions(&inner, request)
                                    .await
                            };
                            Box::pin(fut)
                        }
                    }
                    let accept_compression_encodings = self.accept_compression_encodings;
                    let send_compression_encodings = self.send_compression_encodings;
                    let max_decoding_message_size = self.max_decoding_message_size;
                    let max_encoding_message_size = self.max_encoding_message_size;
                    let inner = self.inner.clone();
                    let fut = async move {
                        let method = ListUserSessionsSvc(inner);
                        let codec = tonic_prost::ProstCodec::default();
                        let mut grpc = tonic::server::Grpc::new(codec)
                            .apply_compression_config(
                                accept_compression_encodings,
                                send_compression_encodings,
                            )
                            .apply_max_message_size_config(
                                max_decoding_message_size,
                                max_encoding_message_size,
                            );
                        let res = grpc.unary(method, req).await;
                        Ok(res)
                    };
                    Box::pin(fut)
                }
                "/admin.SessionAdmin/KickUserFromWorkspace" => {
                    #[allow(non_camel_case_types)]
                    struct KickUserFromWorkspaceSvc<T: SessionAdmin>(pub Arc<T>);
                    impl<
                        T: SessionAdmin,
                    > tonic::server::UnaryService<
                        crate::admin::generated::admin::KickUserFromWorkspaceRequest,
                    > for KickUserFromWorkspaceSvc<T> {
                        type Response = crate::admin::generated::admin::KickUserFromWorkspaceResponse;
                        type Future = BoxFuture<
                            tonic::Response<Self::Response>,
                            tonic::Status,
                        >;
                        fn call(
                            &mut self,
                            request: tonic::Request<
                                crate::admin::generated::admin::KickUserFromWorkspaceRequest,
                            >,
                        ) -> Self::Future {
                            let inner = Arc::clone(&self.0);
                            let fut = async move {
                                <T as SessionAdmin>::kick_user_from_workspace(
                                        &inner,
                                        request,
                                    )
                                    .await
                            };
                            Box::pin(fut)
                        }
                    }
                    let accept_compression_encodings = self.accept_compression_encodings;
                    let send_compression_encodings = self.send_compression_encodings;
                    let max_decoding_message_size = self.max_decoding_message_size;
                    let max_encoding_message_size = self.max_encoding_message_size;
                    let inner = self.inner.clone();
                    let fut = async move {
                        let method = KickUserFromWorkspaceSvc(inner);
                        let codec = tonic_prost::ProstCodec::default();
                        let mut grpc = tonic::server::Grpc::new(codec)
                            .apply_compression_config(
                                accept_compression_encodings,
                                send_compression_encodings,
                            )
                            .apply_max_message_size_config(
                                max_decoding_message_size,
                                max_encoding_message_size,
                            );
                        let res = grpc.unary(method, req).await;
                        Ok(res)
                    };
                    Box::pin(fut)
                }
                "/admin.SessionAdmin/KickUser" => {
                    #[allow(non_camel_case_types)]
                    struct KickUserSvc<T: SessionAdmin>(pub Arc<T>);
                    impl<
                        T: SessionAdmin,
                    > tonic::server::UnaryService<
                        crate::admin::generated::admin::KickUserRequest,
                    > for KickUserSvc<T> {
                        type Response = crate::admin::generated::admin::KickUserResponse;
                        type Future = BoxFuture<
                            tonic::Response<Self::Response>,
                            tonic::Status,
                        >;
                        fn call(
                            &mut self,
                            request: tonic::Request<
                                crate::admin::generated::admin::KickUserRequest,
                            >,
                        ) -> Self::Future {
                            let inner = Arc::clone(&self.0);
                            let fut = async move {
                                <T as SessionAdmin>::kick_user(&inner, request).await
                            };
                            Box::pin(fut)
                        }
                    }
                    let accept_compression_encodings = self.accept_compression_encodings;
                    let send_compression_encodings = self.send_compression_encodings;
                    let max_decoding_message_size = self.max_decoding_message_size;
                    let max_encoding_message_size = self.max_encoding_message_size;
                    let inner = self.inner.clone();
                    let fut = async move {
                        let method = KickUserSvc(inner);
                        let codec = tonic_prost::ProstCodec::default();
                        let mut grpc = tonic::server::Grpc::new(codec)
                            .apply_compression_config(
                                accept_compression_encodings,
                                send_compression_encodings,
                            )
                            .apply_max_message_size_config(
                                max_decoding_message_size,
                                max_encoding_message_size,
                            );
                        let res = grpc.unary(method, req).await;
                        Ok(res)
                    };
                    Box::pin(fut)
                }
                "/admin.SessionAdmin/GetUserStatus" => {
                    #[allow(non_camel_case_types)]
                    struct GetUserStatusSvc<T: SessionAdmin>(pub Arc<T>);
                    impl<
                        T: SessionAdmin,
                    > tonic::server::UnaryService<
                        crate::admin::generated::admin::GetUserStatusRequest,
                    > for GetUserStatusSvc<T> {
                        type Response = crate::admin::generated::admin::GetUserStatusResponse;
                        type Future = BoxFuture<
                            tonic::Response<Self::Response>,
                            tonic::Status,
                        >;
                        fn call(
                            &mut self,
                            request: tonic::Request<
                                crate::admin::generated::admin::GetUserStatusRequest,
                            >,
                        ) -> Self::Future {
                            let inner = Arc::clone(&self.0);
                            let fut = async move {
                                <T as SessionAdmin>::get_user_status(&inner, request).await
                            };
                            Box::pin(fut)
                        }
                    }
                    let accept_compression_encodings = self.accept_compression_encodings;
                    let send_compression_encodings = self.send_compression_encodings;
                    let max_decoding_message_size = self.max_decoding_message_size;
                    let max_encoding_message_size = self.max_encoding_message_size;
                    let inner = self.inner.clone();
                    let fut = async move {
                        let method = GetUserStatusSvc(inner);
                        let codec = tonic_prost::ProstCodec::default();
                        let mut grpc = tonic::server::Grpc::new(codec)
                            .apply_compression_config(
                                accept_compression_encodings,
                                send_compression_encodings,
                            )
                            .apply_max_message_size_config(
                                max_decoding_message_size,
                                max_encoding_message_size,
                            );
                        let res = grpc.unary(method, req).await;
                        Ok(res)
                    };
                    Box::pin(fut)
                }
                "/admin.SessionAdmin/GetUserInfo" => {
                    #[allow(non_camel_case_types)]
                    struct GetUserInfoSvc<T: SessionAdmin>(pub Arc<T>);
                    impl<
                        T: SessionAdmin,
                    > tonic::server::UnaryService<
                        crate::admin::generated::admin::GetUserInfoRequest,
                    > for GetUserInfoSvc<T> {
                        type Response = crate::admin::generated::admin::GetUserInfoResponse;
                        type Future = BoxFuture<
                            tonic::Response<Self::Response>,
                            tonic::Status,
                        >;
                        fn call(
                            &mut self,
                            request: tonic::Request<
                                crate::admin::generated::admin::GetUserInfoRequest,
                            >,
                        ) -> Self::Future {
                            let inner = Arc::clone(&self.0);
                            let fut = async move {
                                <T as SessionAdmin>::get_user_info(&inner, request).await
                            };
                            Box::pin(fut)
                        }
                    }
                    let accept_compression_encodings = self.accept_compression_encodings;
                    let send_compression_encodings = self.send_compression_encodings;
                    let max_decoding_message_size = self.max_decoding_message_size;
                    let max_encoding_message_size = self.max_encoding_message_size;
                    let inner = self.inner.clone();
                    let fut = async move {
                        let method = GetUserInfoSvc(inner);
                        let codec = tonic_prost::ProstCodec::default();
                        let mut grpc = tonic::server::Grpc::new(codec)
                            .apply_compression_config(
                                accept_compression_encodings,
                                send_compression_encodings,
                            )
                            .apply_max_message_size_config(
                                max_decoding_message_size,
                                max_encoding_message_size,
                            );
                        let res = grpc.unary(method, req).await;
                        Ok(res)
                    };
                    Box::pin(fut)
                }
                "/admin.SessionAdmin/GetWorkspaceOnlineUsers" => {
                    #[allow(non_camel_case_types)]
                    struct GetWorkspaceOnlineUsersSvc<T: SessionAdmin>(pub Arc<T>);
                    impl<
                        T: SessionAdmin,
                    > tonic::server::UnaryService<
                        crate::admin::generated::admin::GetWorkspaceOnlineUsersRequest,
                    > for GetWorkspaceOnlineUsersSvc<T> {
                        type Response = crate::admin::generated::admin::GetWorkspaceOnlineUsersResponse;
                        type Future = BoxFuture<
                            tonic::Response<Self::Response>,
                            tonic::Status,
                        >;
                        fn call(
                            &mut self,
                            request: tonic::Request<
                                crate::admin::generated::admin::GetWorkspaceOnlineUsersRequest,
                            >,
                        ) -> Self::Future {
                            let inner = Arc::clone(&self.0);
                            let fut = async move {
                                <T as SessionAdmin>::get_workspace_online_users(
                                        &inner,
                                        request,
                                    )
                                    .await
                            };
                            Box::pin(fut)
                        }
                    }
                    let accept_compression_encodings = self.accept_compression_encodings;
                    let send_compression_encodings = self.send_compression_encodings;
                    let max_decoding_message_size = self.max_decoding_message_size;
                    let max_encoding_message_size = self.max_encoding_message_size;
                    let inner = self.inner.clone();
                    let fut = async move {
                        let method = GetWorkspaceOnlineUsersSvc(inner);
                        let codec = tonic_prost::ProstCodec::default();
                        let mut grpc = tonic::server::Grpc::new(codec)
                            .apply_compression_config(
                                accept_compression_encodings,
                                send_compression_encodings,
                            )
                            .apply_max_message_size_config(
                                max_decoding_message_size,
                                max_encoding_message_size,
                            );
                        let res = grpc.unary(method, req).await;
                        Ok(res)
                    };
                    Box::pin(fut)
                }
                "/admin.SessionAdmin/IsUserOnline" => {
                    #[allow(non_camel_case_types)]
                    struct IsUserOnlineSvc<T: SessionAdmin>(pub Arc<T>);
                    impl<
                        T: SessionAdmin,
                    > tonic::server::UnaryService<
                        crate::admin::generated::admin::IsUserOnlineRequest,
                    > for IsUserOnlineSvc<T> {
                        type Response = crate::admin::generated::admin::IsUserOnlineResponse;
                        type Future = BoxFuture<
                            tonic::Response<Self::Response>,
                            tonic::Status,
                        >;
                        fn call(
                            &mut self,
                            request: tonic::Request<
                                crate::admin::generated::admin::IsUserOnlineRequest,
                            >,
                        ) -> Self::Future {
                            let inner = Arc::clone(&self.0);
                            let fut = async move {
                                <T as SessionAdmin>::is_user_online(&inner, request).await
                            };
                            Box::pin(fut)
                        }
                    }
                    let accept_compression_encodings = self.accept_compression_encodings;
                    let send_compression_encodings = self.send_compression_encodings;
                    let max_decoding_message_size = self.max_decoding_message_size;
                    let max_encoding_message_size = self.max_encoding_message_size;
                    let inner = self.inner.clone();
                    let fut = async move {
                        let method = IsUserOnlineSvc(inner);
                        let codec = tonic_prost::ProstCodec::default();
                        let mut grpc = tonic::server::Grpc::new(codec)
                            .apply_compression_config(
                                accept_compression_encodings,
                                send_compression_encodings,
                            )
                            .apply_max_message_size_config(
                                max_decoding_message_size,
                                max_encoding_message_size,
                            );
                        let res = grpc.unary(method, req).await;
                        Ok(res)
                    };
                    Box::pin(fut)
                }
                _ => {
                    Box::pin(async move {
                        let mut response = http::Response::new(
                            tonic::body::Body::default(),
                        );
                        let headers = response.headers_mut();
                        headers
                            .insert(
                                tonic::Status::GRPC_STATUS,
                                (tonic::Code::Unimplemented as i32).into(),
                            );
                        headers
                            .insert(
                                http::header::CONTENT_TYPE,
                                tonic::metadata::GRPC_CONTENT_TYPE,
                            );
                        Ok(response)
                    })
                }
            }
        }
    }
    impl<T> Clone for SessionAdminServer<T> {
        fn clone(&self) -> Self {
            let inner = self.inner.clone();
            Self {
                inner,
                accept_compression_encodings: self.accept_compression_encodings,
                send_compression_encodings: self.send_compression_encodings,
                max_decoding_message_size: self.max_decoding_message_size,
                max_encoding_message_size: self.max_encoding_message_size,
            }
        }
    }
    /// Generated gRPC service name
    pub const SERVICE_NAME: &str = "admin.SessionAdmin";
    impl<T> tonic::server::NamedService for SessionAdminServer<T> {
        const NAME: &'static str = SERVICE_NAME;
    }
}
